unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TMyThread=class(TThread)
  private
    FL:integer;
    procedure DataOutput;
    procedure ReadValue;
  protected
    procedure Execute; override;
  end;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    FValue:integer;
    procedure ThreadDone(Sender:TObject);
    function GetValue: integer;
  public
    { Public declarations }
    property Value:integer read GetValue;
  end;

var
  Form1: TForm1;

implementation
var
  hSem: THandle = 0;

{$R *.dfm}
procedure TForm1.ThreadDone(Sender: TObject);
begin
  ShowMessage('');
end;

function TForm1.GetValue: integer;
begin
  try
    WaitForSingleObject(hSem, INFINITE);
    Result:=FValue;
  finally
    ReleaseSemaphore(hSem, 1, nil);
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  FValue:=50;
  hSem := CreateSemaphore(nil, 1, 1, nil);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  CloseHandle(hSem);
end;

procedure TMyThread.DataOutput;
begin
  Form1.Label1.Caption:=IntToStr(FL);
end;

procedure TMyThread.ReadValue;
begin
  FL:=Form1.Value;
  try
    WaitForSingleObject(hSem, INFINITE);
    FL:=Form1.Value;
    Form1.FValue:=FL+1;
  finally
    ReleaseSemaphore(hSem,1,nil);
  end;
end;

procedure TMyThread.Execute;
begin
  ReadValue;
  repeat
    Inc(FL);
    Synchronize(DataOutput);
    Sleep(100);
  until (FL>=100) or Terminated;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  with TMyThread.Create(True) do
  begin
    FreeOnTerminate := True;
    OnTerminate := ThreadDone;
    Resume;
  end; 
end;

end.
